(function() {
var GridExportItemType = {
 ExportToPdf: "ExportToPdf",
 ExportToDocx: "ExportToDocx",
 ExportToRtf: "ExportToRtf",
 ExportToCsv: "ExportToCsv",
 ExportToXls: "ExportToXls",
 ExportToXlsx: "ExportToXlsx"
};
var TOOLBAR_CLIENT_STATE_KEY = "toolbar";
var GridCommandMenuHelper = ASPx.CreateClass(null, {
 constructor: function(exportFormat) {
  this.exportFormat = exportFormat;
 },
 GetItemCommand: function(item) {
  return item.menu.cpItemsCommands[item.indexPath];
 },
 IsExportItem: function(itemType) {
  return itemType == GridExportItemType.ExportToPdf
   || itemType == GridExportItemType.ExportToDocx
   || itemType == GridExportItemType.ExportToRtf
   || itemType == GridExportItemType.ExportToCsv
   || itemType == GridExportItemType.ExportToXls
   || itemType == GridExportItemType.ExportToXlsx;
 },
 GetExportFormat: function(exportCommand) {
  var exportFormat = this.exportFormat;
  switch(exportCommand) {
   case GridExportItemType.ExportToPdf:
    return exportFormat.Pdf;
   case GridExportItemType.ExportToDocx:
    return exportFormat.Docx;
   case GridExportItemType.ExportToRtf:
    return exportFormat.Rtf;
   case GridExportItemType.ExportToCsv:
    return exportFormat.Csv;
   case GridExportItemType.ExportToXls:
    return exportFormat.Xls;
   case GridExportItemType.ExportToXlsx:
    return exportFormat.Xlsx;
  }
  return null;
 }
});
var CommandToolbarHelper = ASPx.CreateClass(GridCommandMenuHelper, {
 constructor: function(control, exportFormat) {
  this.constructor.prototype.constructor.call(this, exportFormat);
  this.control = control;
  this.ResetState();
 },
 GetCallbackState: function() {
  if(this.clickedToolbarIndex < 0 || !this.clickedToolbarMenuItem)
   return null;
  return this.clickedToolbarIndex + ";" + this.clickedToolbarMenuItem.indexPath;
 },
 ResetState: function() {
  this.clickedToolbarIndex = -1;
  this.clickedToolbarMenuItem = null;
  this.SetClientStateValue(null);
 },
 SaveClientState: function() {
  this.SetClientStateValue(this.GetCallbackState());
 },
 SetClientStateValue: function(value) {
  this.control.stateObject[TOOLBAR_CLIENT_STATE_KEY] = value;
 },
 GetToolbarSettings: function() {
  return this.control.toolbars;
 },
 GetToolbarByIndex: function(index) {
  return this.control.GetToolbar(index);
 },
 GetToolbarByName: function(name) {
  var settings = this.GetToolbarSettings();
  var foundToolbars = settings.filter(function(t) { return t.name === name; });
  if(foundToolbars.length < 1)
   return null;
  return this.GetToolbarByIndex(foundToolbars[0].index);
 },
 GetToolbarNameByIndex: function(index) {
  var settings = this.GetToolbarSettings(),
   foundToolbars = settings.filter(function(t) { return t.index === index; });
  return (foundToolbars.length > 0) ? foundToolbars[0].name : null;
 },
 GetToolbarIndexByName: function(name) {
  var index = -1;
  var success = false;
  var n = name.length - 1;
  while(n >= 0 && !isNaN(parseInt(name.substr(n), 10))) {
   index = parseInt(name.substr(n), 10);
   success = true;
   n--;
  }
  return success ? index: -1;
 },
 InitializeCustomizationWindowHandlers: function() {
  var custWindow = this.GetCustomizationWindow();
  if(custWindow) {
   custWindow.PopUp.AddHandler(function() {
    this.SetCheckedItemsState(this.IsShowCustomizationWindowItem, true);
   }.aspxBind(this));
   custWindow.CloseUp.AddHandler(function() {
    this.SetCheckedItemsState(this.IsShowCustomizationWindowItem, false);
   }.aspxBind(this));
  }
 },
 OnInit: function() {
  this.InitializeCustomizationWindowHandlers();
 },
 OnAfterCallback: function() {
  this.ResetState();
  this.InitializeCustomizationWindowHandlers();
 },
 RefreshItemsState: function() {
  this.ForEachItem(null, this.RefreshItemState.aspxBind(this));
 },
 SetCheckedItemsState: function(filterFunc, checked) {
  var setCheckedFunc = function(item) { item.SetChecked(checked); };
  this.ForEachItem(filterFunc, setCheckedFunc);
 },
 OnUpdateEditEnabledChanged: function(enabled) {
  var setEnabledFunc = function(item) { item.SetEnabled(enabled); };
  this.ForEachItem(this.IsUpdateEditItem.aspxBind(this), setEnabledFunc);
 },
 RefreshItemState: function(item) {
  this.RefreshItemText(item);
  this.RefreshItemEnabled(item);
 },
 RefreshSelectionBasedItemText: function(item, gridItemCount) {
  var text = item.GetText();
  var newText = text;
  var postfixIndex = text.lastIndexOf("(");
  if(postfixIndex !== -1)
   newText = text.substring(0, postfixIndex - 1);
  if(gridItemCount > 1)
   newText += " (" + gridItemCount.toString() + ")";
  if(newText != text)
   item.SetText(newText);
 },
 RefreshItemEnabled: function(item) {
  var itemEnabled = this.GetToolbarItemEnabled(item);
  if(itemEnabled !== null)
   item.SetEnabled(itemEnabled);
 },
 ForEachItem: function(filterFunc, actionFunc) {
  var settings = this.GetToolbarSettings();
  for(var i = 0; i < settings.length; i++){
   var menu = this.GetToolbarByIndex(settings[i].index);
   this.ForEachItemInternal(menu, filterFunc, actionFunc);
  }
 },
 ForEachItemInternal: function(itemsOwner, filterFunc, actionFunc) {
  for(var i = 0; i < itemsOwner.GetItemCount(); i++){
   var item = itemsOwner.GetItem(i);
   if(!filterFunc || filterFunc(item))
    actionFunc(item);
   this.ForEachItemInternal(item, filterFunc, actionFunc);
  }
 },
 RefreshItemText: function(item) {
 },
 GetToolbarItemEnabled: function(item){
  return null;
 },
 IsUpdateEditItem: function(item) {
  return false;
 },
 GetCustomizationWindow: function() {
  return null;
 },
 IsShowCustomizationWindowItem: function(item) {
  return false;
 },
 GetSelectedGridItemCount: function() {
  return 0;
 },
 GetSelectedVisibleGridItemCount: function() {
  return 0;
 },
 OnToolbarMenuItemClick: function(toolbar, e) {
  this.clickedToolbarIndex = this.GetToolbarIndexByName(toolbar.name);
  this.clickedToolbarMenuItem = e.item;
  this.SaveClientState();
  var clickedToolbarInfo = { index: this.clickedToolbarIndex, name: this.GetToolbarNameByIndex(this.clickedToolbarIndex) },
   handled = this.control.RaiseToolbarItemClick(clickedToolbarInfo, e.item);
  if(!handled)
   this.ProcessToolbarItemClick(e);
  this.ResetState();
 },
 ProcessToolbarItemClick: function(e) {
  var item = e.item,
   command = this.GetItemCommand(item);
  if(this.IsExportItem(command))
   this.ToolbarExport(command);
 },
 ToolbarExport: function(exportCommand) {
  var exportFormat = this.GetExportFormat(exportCommand);
  this.control.ExportTo(exportFormat);
 },
 ProcessCustomToolbarItemClickOnServer: function(usePostBack) {
 }
});
var GridToolbarHelper = ASPx.CreateClass(CommandToolbarHelper, {
 constructor: function(grid) {
  this.constructor.prototype.constructor.call(this, grid, ASPx.ASPxClientGridExportFormat);
  this.grid = grid;
 },
 ProcessCustomToolbarItemClickOnServer: function(usePostBack) {
  var args = [ "" ];
  if(usePostBack)
   this.SendToolbarPostback(args);
  else
   this.SendToolbarCallback(args);
 },
 SendToolbarCallback: function(args) {
  this.grid.gridCallBack([ ASPxClientGridViewCallbackCommand.Toolbar ].concat(args));
 },
 SendToolbarPostback: function(toolbarCommand) {
  this.grid.gridPostBack([ASPxClientGridViewCallbackCommand.Toolbar, toolbarCommand]);
 },
 ToolbarStartEdit: function() {
  if(this.IsBatchEditMode()) {
   var visibleIndex = 0;
   var columnIndex = 0;
   var cellInfo = this.GetFocusedCellInfo();
   if(cellInfo) {
    visibleIndex = this.grid.ConvertKeyToVisibleIndex(cellInfo.recordKey);
    columnIndex = cellInfo.columnIndex;
   }
   this.grid.batchEditApi.StartEdit(visibleIndex, columnIndex);
  }
  else
   this.grid.StartEditItem(this.GetFocusedItemIndex());
 },
 ToolbarDeleteItem: function() {
  var focusedItemIndex = this.GetFocusedItemIndex();
  if(focusedItemIndex == -1 && this.IsBatchEditMode()) {
   var cellInfo = this.GetFocusedCellInfo();
   if(cellInfo)
    focusedItemIndex = this.grid.ConvertKeyToVisibleIndex(cellInfo.recordKey);
  }
  this.grid.DeleteGridItem(focusedItemIndex);
 },
 ToolbarDeleteSelectedVisibleItems: function() {
  this.ToolbarDeleteSelectedItemsInternal("DeleteSelectedVisible");
 },
 ToolbarDeleteSelectedItemsInternal: function(commandName) {
  if(this.IsBatchEditMode()) {
   var keys = this.grid.GetSelectedKeysOnPage();
   for(var i = 0, key; key = keys[i]; i++)
    this.grid.DeleteItemByKey(key);
  }
  else
   this.SendToolbarCallback([ commandName ]);
 },
 GetFocusedItemIndex: function(){
  return this.control._getFocusedItemIndex();
 },
 GetFocusedCellInfo: function() {
  var helper = this.control.GetCellFocusHelper();
  return helper ? helper.GetFocusedCellInfo() : null;
 },
 GetSelectedGridItemCount: function() {
  return this.control._getSelectedRowCount();
 },
 GetSelectedVisibleGridItemCount: function() {
  return this.control._getSelectedRowCountOnPage();
 },
 GetCustomizationWindow: function() {
  return this.grid.GetCustomizationWindow();
 },
 IsEditingItem: function(visibleIndex){
  return this.control.IsEditingItem(visibleIndex);
 },
 IsBatchEditMode: function(){
  return this.control.GetBatchEditHelper();
 },
 HasBatchEditFocusedCell: function() {
  return this.IsBatchEditMode() && this.GetFocusedCellInfo();
 }
});
ASPx.GridExportItemType = GridExportItemType;
ASPx.GridCommandMenuHelper = GridCommandMenuHelper;
ASPx.CommandToolbarHelper = CommandToolbarHelper;
ASPx.GridToolbarHelper = GridToolbarHelper;
})();
